#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <stdint.h>
#include <errno.h>

#include <time.h>
#include <string.h>

#define osErrorFatal(userMsg) osErrorFatalImpl((userMsg), __FILE__, __func__, __LINE__)
#define osAssert(expr, userMsg) \
    do { \
        if (!(expr)) \
            osErrorFatal(userMsg); \
    } while(0)
    
#define MAX_SIZE (1024)
    
static const char *os_Usage = "";
    
void osErrorFatalImpl(const char *userMsg, const char *fileName, 
                      const char *functionName, const int lineNum);

int main(int argc, char** argv) {
	
	/* citamo trenutno vreme u sekundama */
	time_t now = time(NULL);
	/* dobijamo string reprezentaciju vremena */
	char* s = ctime(&now);
	/* uklanjamo novi red koji ctime uvek postavlja*/
	s[strlen(s) - 1] = 0;
	/* stampamo broj */
	printf("%s\n", s);
	
	/* prebacujemo vreme u format citljiv za koristika */
	struct tm* timeStruct = localtime(&now);
	osAssert(timeStruct != NULL, "localtime failed");
	char msgBuf[MAX_SIZE];
	/* pravimo prilagodjeni i formatirani ispis vremena */
	strftime(msgBuf, MAX_SIZE, "Dan: %A\nMesec: %B\nNedelja u godini: %W\n", timeStruct);
	/* stampamo dobijeni string */
	printf("Formatirano vreme:\n%s", msgBuf);
	
	exit(EXIT_SUCCESS);
}

void osErrorFatalImpl(const char *userMsg, const char *fileName, 
                      const char *functionName, const int lineNum) {
    perror(userMsg);
    fprintf(stderr, "File: '%s'\nFunction: '%s'\nLine: '%d'\n", fileName, functionName, lineNum);
    exit(EXIT_FAILURE);
}
